﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Drawing;
using HeuristicLab.Persistence.Data;

namespace HeuristicLab.Persistence {
  [Transformer("2E6D4A40-B4BE-425F-8E35-2D7C00054639", 220)]
  internal sealed class PointTransformer : TransformerBase {
    public override bool CanTransformType(Type type) {
      return type == typeof(Point);
    }
    public override PersistenceData ToData(object o, PersistenceMapper mapper) {
      var point = (Point)o;
      var data = new ArrayData<int>(Id);
      data.TypeId = mapper.GetTypeId(o.GetType());
      data.Values = new int[2];
      data.Values[0] = point.X;
      data.Values[1] = point.Y;
      return data;
    }

    public override object ToObject(PersistenceData data, PersistenceMapper mapper) {
      var pointData = (ArrayData<int>)data;
      return new Point(pointData.Values[0], pointData.Values[1]);
    }
  }
}
